> This page is for Unified.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.merge.dev/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.merge.dev/_mcp/server.

# /containers

GET https://api.merge.dev/api/knowledgebase/v1/containers

Returns a list of `Container` objects.

Reference: https://docs.merge.dev/merge-unified/knowledge-base/common-models/containers/list

## Authentication

- `Authorization` header (bearer token, required) — Token-based authentication with required prefix "Bearer"

## Servers

- `https://api.merge.dev/api` (Production, default)
- `https://api-eu.merge.dev/api` (ProductionEU)
- `https://api-ap.merge.dev/api` (ProductionAPSE1)
- `https://api-ap.merge.dev/api/knowledgebase/v1` (ProductionAPSE1)

## Request

### Query parameters

- `created_after` (datetime, optional) — If provided, will only return objects created after this datetime.
- `created_before` (datetime, optional) — If provided, will only return objects created before this datetime.
- `cursor` (string, optional) — The pagination cursor value.
- `expand` (enum, optional) — Which relations should be returned in expanded form. Multiple relation names should be comma separated without spaces.
  - Allowed values: `parent_article`, `parent_article,parent_container`, `parent_container`, `permissions`, `permissions,parent_article`, `permissions,parent_article,parent_container`, `permissions,parent_container`
- `include_deleted_data` (boolean, optional) — Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/).
- `include_remote_data` (boolean, optional) — Whether to include the original data Merge fetched from the third-party to produce these models.
- `include_shell_data` (boolean, optional) — Whether to include shell records. Shell records are empty records (they may contain some metadata but all other fields are null).
- `modified_after` (datetime, optional) — If provided, only objects synced by Merge after this date time will be returned.
- `modified_before` (datetime, optional) — If provided, only objects synced by Merge before this date time will be returned.
- `page_size` (integer, optional) — Number of results to return per page. The maximum limit is 100.
- `parent_article_id` (string, optional) — If provided, will only return sub containers of the parent_article_id.
- `parent_container_id` (string, optional) — If provided, will only return sub containers of the parent_container_id.
- `remote_id` (string, optional) — The API provider's ID for the given object.
- `type` (enum, optional) — If provided, will only return containers of the given type.
  - Allowed values: ``, `CATEGORY`, `COLLECTION`, `DATABASE`, `FOLDER`, `SECTION`, `SPACE`

### Headers

- `X-Account-Token` (string, required) — Token identifying the end user.

## Response

### 200

- `next` (string, optional, nullable)
- `previous` (string, optional, nullable)
- `results` (list of Container, optional)

## Types

### Container

# The Container Object ### Description The Container object is used to represent a grouping of articles in the knowledge base. This can include Spaces, Folders, Databases, etc. ### Usage Example Fetch from the `GET /api/knowledgebase/containers` endpoint and view their containers.

- `id` (string, optional)
- `remote_id` (string, optional, nullable) — The third-party API ID of the matching object.
- `created_at` (datetime, optional) — The datetime that this object was created by Merge.
- `modified_at` (datetime, optional) — The datetime that this object was modified by Merge.
- `name` (string, optional, nullable) — Name of the container.
- `description` (string, optional, nullable) — Description of the container.
- `status` (enum, optional, nullable) — The container's status. * `DRAFT` - DRAFT * `PUBLISHED` - PUBLISHED * `ARCHIVED` - ARCHIVED * `TRASH` - TRASH
  - Allowed values: `DRAFT`, `PUBLISHED`, `ARCHIVED`, `TRASH`
- `container_url` (string, optional, nullable) — The URL to the webpage of the container.
- `type` (enum, optional, nullable) — The container's type. * `FOLDER` - FOLDER * `SPACE` - SPACE * `COLLECTION` - COLLECTION * `SECTION` - SECTION * `CATEGORY` - CATEGORY * `DATABASE` - DATABASE
  - Allowed values: `FOLDER`, `SPACE`, `COLLECTION`, `SECTION`, `CATEGORY`, `DATABASE`
- `visibility` (enum, optional, nullable) — The container's visibility. * `PUBLIC` - PUBLIC * `INTERNAL` - INTERNAL * `RESTRICTED` - RESTRICTED
  - Allowed values: `PUBLIC`, `INTERNAL`, `RESTRICTED`
- `remote_created_at` (datetime, optional, nullable) — When the third party's container was created.
- `remote_updated_at` (datetime, optional, nullable) — When the third party's container was updated.
- `parent_article` (string, optional, nullable) — The parent article a container is nested within.
- `parent_container` (string, optional, nullable) — The parent container a container is nested within.
- `permissions` (list of Permission, optional)
- `remote_was_deleted` (boolean, optional) — Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/).
- `field_mappings` (ContainerFieldMappings, optional, nullable)
- `remote_data` (list of RemoteData, optional, nullable)

### Permission

# The Permission Object ### Description The `Permission` object is used to represent a user's or group's access to an article or container. Permissions are unexpanded by default. ### Usage Example

- `id` (string, optional)
- `remote_id` (string, optional, nullable) — The third-party API ID of the matching object.
- `created_at` (datetime, optional) — The datetime that this object was created by Merge.
- `modified_at` (datetime, optional) — The datetime that this object was modified by Merge.
- `user` (string, optional, nullable)
- `group` (string, optional, nullable)
- `type` (enum, optional, nullable) — Denotes what type of people have access to the Article or Container. * `USER` - USER * `GROUP` - GROUP * `COMPANY` - COMPANY * `ANYONE` - ANYONE
  - Allowed values: `USER`, `GROUP`, `COMPANY`, `ANYONE`
- `roles` (list of enum, optional, nullable) — The permissions that the user or group has for the Article or Container. It is possible for a user or group to have multiple roles, such as viewing & uploading.
  - Allowed values: `READ`, `WRITE`, `OWNER`
- `remote_was_deleted` (boolean, optional) — Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/).
- `field_mappings` (PermissionFieldMappings, optional, nullable)

### ContainerFieldMappings

### RemoteData

# The RemoteData Object ### Description The `RemoteData` object is used to represent the full data pulled from the third-party API for an object.

- `path` (string, required) — The third-party API path that is being called.
- `data` (any, optional) — The data returned from the third-party for this object in its original, unnormalized format.

### PermissionFieldMappings

## Examples

**Response**

```json
{
  "next": "cD0yMDIxLTAxLTA2KzAzJTNBMjQlM0E1My40MzQzMjYlMkIwMCUzQTAw",
  "previous": "cj1sZXdwd2VycWVtY29zZnNkc2NzUWxNMEUxTXk0ME16UXpNallsTWtJ",
  "results": [
    {
      "id": "134e0111-0f67-44f6-98f0-597000290bb3",
      "remote_id": "800293",
      "created_at": "2021-09-15T00:00:00Z",
      "modified_at": "2021-10-16T00:00:00Z",
      "name": "Test Container",
      "description": "This folder contains articles that describe how Merge is the #1 player in the Unified API space",
      "status": "DRAFT",
      "container_url": "myworkspace.atlassian.net/wiki/test-container",
      "type": "SPACE",
      "visibility": "INTERNAL",
      "remote_created_at": "2021-09-15T00:00:00Z",
      "remote_updated_at": "2021-09-16T00:00:00Z",
      "parent_article": "string",
      "parent_container": "8e889422-e086-42dc-b99e-24d732039b0b",
      "permissions": [
        {
          "id": "31ce489c-asdf-68b1-754r-629f799f7123",
          "remote_id": "102895",
          "created_at": "2020-03-31T00:00:00Z",
          "modified_at": "2020-06-20T00:00:00Z",
          "user": "21ce474c-asdf-34a2-754r-629f799f7d12",
          "group": null,
          "type": "USER",
          "roles": [
            "OWNER"
          ],
          "remote_data": null
        }
      ],
      "remote_was_deleted": true,
      "field_mappings": {
        "linked_account_defined_targets": {
          "custom_key": "custom_value"
        },
        "organization_defined_targets": {
          "custom_key": "custom_value"
        }
      },
      "remote_data": [
        {
          "path": "/containers",
          "data": null
        }
      ]
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.merge.dev/api/knowledgebase/v1/containers"

querystring = {"include_remote_data":"true"}

headers = {
    "X-Account-Token": "X-Account-Token",
    "Authorization": "Bearer <token>"
}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true';
const options = {
  method: 'GET',
  headers: {'X-Account-Token': 'X-Account-Token', Authorization: 'Bearer <token>'}
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("X-Account-Token", "X-Account-Token")
	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["X-Account-Token"] = 'X-Account-Token'
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true")
  .header("X-Account-Token", "X-Account-Token")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'X-Account-Token' => 'X-Account-Token',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true");
var request = new RestRequest(Method.GET);
request.AddHeader("X-Account-Token", "X-Account-Token");
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Account-Token": "X-Account-Token",
  "Authorization": "Bearer <token>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.merge.dev/api/knowledgebase/v1/containers?include_remote_data=true")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```